/** @file ListAexcept.cpp */

// ***********************************************************
// Implementation file ListA.cpp for the ADT list
// Array-based implementation modified from Carrano p. 158-59
// ***********************************************************

#include "ListAexcept.h" //header file

List::List() : size(0)
{
} // end default constructor

bool List::isEmpty() const
{
   return bool(size == 0);
} // end isEmpty

int List::getLength() const
{
   return size;
} // end getLength

void List::insert(int index, ListItemType newItem)	
	throw(ListIndexOutOfRangeException, ListException)
{	//Insertion function from page 156
   if (size >= MAX_LIST)
      throw ListException(
         "ListException: List full on insert");

   if (index >= 1 && index <= size+1)
   {
      for (int pos = size; pos >= index; --pos)
        items[translate(pos+1)] = items[translate(pos)];
      // insert new item
      items[translate(index)] = newItem;
      ++size; // increase the size of the list by one
   }
   else // index out of range
     throw ListIndexOutOfRangeException(
      "ListIndexOutOfRangeException: Bad index on insert");
   // end if
} // end insert


void List::remove(int index)
	throw(ListIndexOutOfRangeException)
{
   //You need to implement this function to throw exceptions

} // end remove

void List::retrieve(int index, ListItemType& dataItem) const
	throw(ListIndexOutOfRangeException)
{
   //You need to implement this function to throw exceptions

} // end retrieve

int List::translate(int index) const
{
   return index-1;
} // end translate
// End of implementation file.

