/** @file ListException.h 
  * ListException Class (Carrano p. 162 modified)
  */

#ifndef _LIST_EXCEPT_H
#define _LIST_EXCEPT_H

#include <stdexcept>
#include <string>

/// ListException class
/** 
  * Exception class for full lists
  */
class ListException: public std::logic_error
{
public:
  /**
   * Creates exception itialized with a message.
   * @param message exception message string
   */
   ListException(const std::string & message = "")
          : std::logic_error(message.c_str())		
   { }
}; // end ListException

#endif
